<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.viewflows.ui.FlowsAdminServiceStub" %>
<%@ page import="org.wso2.carbon.viewflows.ui.types.AxisConfigData" %>
<%@ page import="org.wso2.carbon.viewflows.ui.types.PhaseOrderData" %>
<%@ page import="org.wso2.carbon.viewflows.ui.types.PhaseData" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.apache.axis2.client.ServiceClient" %>
<%@ page import="org.apache.axis2.client.Options" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>

<link href="extensions/core/css/handler_flow.css" rel="stylesheet" type="text/css" media="all"/>

<%
    String operationName = request.getParameter("opName");
    String serviceName = request.getParameter("serviceName");

    //Obtaining the client-side ConfigurationContext instance.
    ConfigurationContext configContext = (ConfigurationContext) config.getServletContext()
            .getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    //Server URL which is defined in the server.xml
    String serverURL = CarbonUIUtil.getServerURL(config.getServletContext(),
            session) + "FlowsAdminService";

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    AxisConfigData configData;
    try {
        FlowsAdminServiceStub stub = new FlowsAdminServiceStub(configContext, serverURL);
        ServiceClient client = stub._getServiceClient();
        Options option = client.getOptions();
        option.setManageSession(true);
        option.setProperty(org.apache.axis2.transport.http.HTTPConstants.COOKIE_STRING, cookie);

        if (serviceName != null && operationName != null) {
            configData = stub.getOperationAxisConfigData(serviceName, operationName);
        } else {
            configData = stub.getAxisConfigData();
        }
    } catch (Exception e) {
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
        %>
        <jsp:include page="../admin/error.jsp"/>
        <%
        return;
    }

    PhaseOrderData inflowPhaseOrderData = configData.getInflowPhaseOrder();
    PhaseOrderData outflowPhaseOrderData = configData.getOutflowPhaseOrder();
    PhaseOrderData infaultflowPhaseOrderData = configData.getInfaultflowPhaseOrder();
    PhaseOrderData outfaultflowPhaseOrderData = configData.getOutfaultPhaseOrder();
%>

<fmt:bundle basename="org.wso2.carbon.viewflows.ui.i18n.Resources">
<carbon:breadcrumb label="message.flows"
		resourceBundle="org.wso2.carbon.viewflows.ui.i18n.Resources"
		topPage="true" request="<%=request%>" />

    <div id="middle">
        <h2><fmt:message key="message.flows"/> (<fmt:message key="graphical.view"/>)</h2>

        <div id="workArea">
            <p>
                <% if (serviceName != null && operationName != null) {%>
<a href="text_view.jsp?serviceName=<%=serviceName %>&opName=<%= operationName%>&retainlastbc=true" class="icon-link" style="background-image:url(extensions/core/images/text-view.gif);"><fmt:message key="show.text.view"/></a>
                <%
                    } else {
                %>
<a href="text_view.jsp?retainlastbc=true" class="icon-link" style="background-image:url(extensions/core/images/text-view.gif);"><fmt:message key="show.text.view"/></a>
                <% } %>
            </p>
            <p>&nbsp;</p><br/>
            
            <div>
		<h4><fmt:message key="in.flow"/></h4>
                <table id="inFlowChain">
                    <tbody>
                    <tr>
                        <td>
                            <table border="0" cellspacing="0" cellpadding="0">
                                <tr>
                                    <td>
                                        <img src="extensions/core/images/handlerChain_leftmost_inflow.gif"/>
                                    </td>
                                    <%
                                        int position = 0;
                                        for (PhaseData phaseData : inflowPhaseOrderData.getPhases()) {
                                            position++;
                                            String handlerColor = ((position % 2) == 1) ? "handler_01" : "handler_02";
                                            if (position != 1) {%>
                                    <td>
                                        <img src="extensions/core/images/<%= handlerColor%>_left.gif"
                                             border="0px"/>
                                    </td>
                                    <%
                                        } %>
                                    <td id="<%= handlerColor%>_BG">
                                        <a href="handlers.jsp?retainlastbc=true&flow=in&phase=<%=phaseData.getName()%>"><%=phaseData.getName()%>
                                        </a>
                                    </td>
                                    <td>
                                        <img src="extensions/core/images/<%= handlerColor%>_right.gif"
                                             border="0px"/>
                                    </td>
                                    <%
                                        } %>
                                    <td>
                                        <img src="extensions/core/images/handlerChain_rightmost_inflow.gif"/>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    </tbody>
                </table>
                <br/>
		<h4><fmt:message key="out.flow"/></h4>
                <table id="outFlowChain">
                    <tbody>
                    <tr>
                        <td>
                            <table border="0" cellspacing="0" cellpadding="0">
                                <tr>
                                    <td>
                                        <img src="extensions/core/images/handlerChain_leftmost_outflow.gif"/>
                                    </td>
                                    <%
                                        position = 0;
                                        for (PhaseData phaseData : outflowPhaseOrderData.getPhases()) {
                                            position++;
                                            String handlerColor = ((position % 2) == 1) ? "handler_01" : "handler_02";
                                            if (position != 1) {%>
                                    <td>
                                        <img src="extensions/core/images/<%= handlerColor%>_left.gif"
                                             border="0px"/>
                                    </td>
                                    <%
                                        } %>
                                    <td id="<%= handlerColor%>_BG">
                                        <a href="handlers.jsp?retainlastbc=true&flow=out&phase=<%=phaseData.getName()%>"><%=phaseData.getName()%>
                                        </a>
                                    </td>
                                    <td>
                                        <img src="extensions/core/images/<%= handlerColor%>_right.gif"
                                             border="0px"/>
                                    </td>
                                    <%
                                        } %>
                                    <td>
                                        <img src="extensions/core/images/handlerChain_rightmost_outflow.gif"/>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    </tbody>
                </table>
                <br/>
		<h4><fmt:message key="in.fault.flow"/></h4>
                <table id="inFaultFlowChain">
                    <thead>
                    <tr>
                        <td>
                            <table border="0" cellspacing="0" cellpadding="0">
                                <tr>
                                    <td>
                                        <img src="extensions/core/images/handlerChain_leftmost_inflow.gif"/>
                                    </td>
                                    <%
                                        position = 0;
                                        for (PhaseData phaseData : infaultflowPhaseOrderData.getPhases()) {
                                            position++;
                                            String handlerColor = ((position % 2) == 1) ? "handler_01" : "handler_02";
                                            if (position != 1) {%>
                                    <td>
                                        <img src="extensions/core/images/<%= handlerColor%>_left.gif"
                                             border="0px"/>
                                    </td>
                                    <%
                                        } %>
                                    <td id="<%= handlerColor%>_BG">
                                        <a href="handlers.jsp?retainlastbc=true&flow=inFault&phase=<%=phaseData.getName()%>"><%=phaseData.getName()%>
                                        </a>
                                    </td>
                                    <td>
                                        <img src="extensions/core/images/<%= handlerColor%>_right.gif"
                                             border="0px"/>
                                    </td>
                                    <%
                                        } %>
                                    <td>
                                        <img src="extensions/core/images/handlerChain_rightmost_inflow.gif"/>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    </thead>
                </table>
                <br/>
		<h4><fmt:message key="out.fault.flow"/></h4>
                <table id="outFaultFlowChain">
                    <tbody>
                    <tr>
                        <td>
                            <table border="0" cellspacing="0" cellpadding="0">
                                <tr>
                                    <td>
                                        <img src="extensions/core/images/handlerChain_leftmost_outflow.gif"/>
                                    </td>
                                    <%
                                        position = 0;
                                        for (PhaseData phaseData : outfaultflowPhaseOrderData.getPhases()) {
                                            position++;
                                            String handlerColor = ((position % 2) == 1) ? "handler_01" : "handler_02";
                                            if (position != 1) {%>
                                    <td>
                                        <img src="extensions/core/images/<%= handlerColor%>_left.gif"
                                             border="0px"/>
                                    </td>
                                    <%
                                        } %>
                                    <td id="<%= handlerColor%>_BG">
                                        <a href="handlers.jsp?retainlastbc=true&flow=outFault&phase=<%=phaseData.getName()%>"><%=phaseData.getName()%>
                                        </a>
                                    </td>
                                    <td>
                                        <img src="extensions/core/images/<%= handlerColor%>_right.gif"
                                             border="0px"/>
                                    </td>
                                    <%
                                        } %>
                                    <td>
                                        <img src="extensions/core/images/handlerChain_rightmost_outflow.gif"/>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    </tbody>
                </table><br/>
            </div>
        </div>
    </div>

</fmt:bundle>